跳到主要内容

Bank Debit

信息

本文档无中文版本,

请查看其他语言。

Endpoint for Bank API


Mobage Simplified Chinese Platform

Production Bankhttp://sp.mobage-platform.cn/social/api/restful/v2.02
Sandbox Bankhttp://sp.sb.mobage-platform.cn/social/api/restful/v2.02
EnvironmentURL
------

Mobage Traditional Chinese Platform

EnvironmentURL
Production Bankhttp://sp.mobage-platform.tw/social/api/restful/v2.02
Sandbox Bankhttp://sp.sb.mobage-platform.tw/social/api/restful/v2.02
API NameHTTP MethodREST URI FragmentDescription
Get Bank DebitGET/bank/debit/{appId}/{-list|,|transactionId}Retrieve transaction resource or collection.
Create Bank DebitPOST/bank/debit/{appId}Create a transaction resource.
Update Bank DebitPUT/bank/debit/{appId}/{transactionId}Update a transaction resource.

Data Type Definition

BankTransaction

NameTypeDescription
idStringUnique transaction identifier
itemsBankBillingItem, Array<BankBillingItem>Billing items
commentStringAny comment for developer
stateString"new" / "authorized" / "open" / "closed" / "canceled"
publishedDatePublish date of this transaction
updatedDateLast updated date of this transaction

 BankBillingItem

NameTypeDescription
itemBankItemItem to bill
quantityNumberQuantity to bill

BankItem

NameTypeDescription
idStringUnique item identifier. ALPHA / DIGIT / "_". 64 or less characters.
nameStringItem name
priceNumberItem price
descriptionStringItem description
imageUrlStringImage URL of the Item

 

Create Bank Debit

Description​

Create a transaction resource.

URI Fragment​

/bank/debit/{appId}

Supported Formats​

JSON

HTTP Method​

POST

Request Headers​

Any request to the Mobage REST APIs must include the Authorization header. For more details, see How to add the Authorization Header . 

REST Query and URI Template Parameters​

NameTypeRequired/OptionalParameterDescription
appIdAppIdRequiredURI Template ParametersOnly @app is specifiable

Request Body​

BankTransaction

Response Status Code​

HTTP Status CodeHTTP Status MessageMeaning
201CreatedData successfully created
400Bad RequestCorrupt request data on the client side
401UnauthorizedAuthorization error
403ForbiddenThe resource exists, but access is not possible due to a reason other than an authorization error.
404Not FoundThe resource doesn’t exist
500Internal Server ErrorAn error on the API server side
503Service UnavailableThe API cannot be used temporarily

Response Body​

The response body contains a single JSON object with 1 property. The following table describes the property of the JSON object in the response body.

NameTypeDescription
idStringtransaction id

Example. Create Single Transaction Resource with Item Detail​

HTTPS Request

POST /social/api/restful/v2.02/bank/debit/@app
Content-Type: application/json; charset=utf-8

{
"items": [
{
"item": {
"id": "ZZZZZZZZZ",
"name": "Sample Item",
"price": 100,
"description": "This is a sample item",
"imageUrl": "http://server/images/ZZZZZZZZZ.png"
},
"quantity": 10
}
],
"comment" : "hogehoge",
"state" : "new"
}

HTTPS Response

HTTP/1.1 201 Created
Content-Type: application/json; charset=utf-8

{"id" : "08EB3775-92FB-34E6-83F1-C98854C924AD"}

Get Bank Debit

Description​

Retrieve transaction resource or collection.

URI Fragment​

/bank/debit/{appId}/{-list|,|transactionId}

Supported Formats​

JSON

HTTP Method​

GET

REST Query and URI Template Parameters​

NameTypeRequired/OptionalParameterDescription
appIdAppIdRequiredURI Template ParametersOnly @app is specifiable
transactionIdTransactionId, Array<TransactionId>RequiredURI Template Parameters 
fieldsArrayOptionalQuery String 
formatStringOptionalQuery StringOnly json is specifiable

Request Headers​

Any request to the Mobage REST APIs must include the Authorization header. For more details, see How to add the Authorization Header . 

Request Body​

None

Response Status Code​

HTTP Status CodeHTTP Status MessageMeaning
200OKData successfully acquired
400Bad RequestCorrupt request data on the client side
401UnauthorizedAuthorization error
403ForbiddenThe resource exists, but access is not possible due to a reason other than an authorization error.
404Not FoundThe resource doesn’t exist
500Internal Server ErrorAn error on the API server side
503Service UnavailableThe API cannot be used temporarily

Response Body​

BankTransaction

Example. Retrieve Single Transaction Resource​

HTTPS Request

GET /social/api/restful/v2.02/bank/debit/@app/08EB3775-92FB-34E6-83F1-C98854C924AD

HTTPS Response

HTTP/1.1 200 OK
Content-Type: application/json; charset=utf-8

{
"id" : "08EB3775-92FB-34E6-83F1-C98854C924AD",
"items": [
{
"item": {
"id": "XXXXXXXXX"
},
"quantity": 10
}
],
"comment" : "hogehoge",
"state" : "open",
"published" : "2011-03-04T13:31:18",
"updated" : "2011-03-04T13:32:00"
}

Update Bank Debit

Description​

Update a transaction resource.

URI Fragment​

/bank/debit/{appId}/{transactionId}

Supported Formats​

JSON

HTTP Method​

PUT

REST Query and URI Template Parameters​

NameTypeRequired/OptionalParameterDescription
appIdAppIdRequiredURI Template ParametersOnly @app is specifiable
transactionIdTransactionId, Array<TransactionId>RequiredURI Template Parameters 
fieldsArrayOptionalQuery String 
formatStringOptionalQuery StringOnly json is specifiable

Request Body​

BankTransaction

Request Headers​

Any request to the Mobage REST APIs must include the Authorization header. For more details, see How to add the Authorization Header . 

Response Body​

BankTransaction

Response Status Code​

HTTP Status CodeHTTP Status MessageMeaning
202AcceptedData successfully updated
400Bad RequestCorrupt request data on the client side
401UnauthorizedAuthorization error
403ForbiddenThe resource exists, but access is not possible due to a reason other than an authorization error.
404Not FoundThe resource doesn’t exist
409ConflictIllegal state
500Internal Server ErrorAn error on the API server side

Notes​

A new state can only be updated to authorized.

An authorized state can only be updated to open.

An open state can only be updated to closed.

A closed state cannot be updated to canceled.

Example. Update Single Transaction Resouce​

HTTPS Request

PUT /social/api/restful/v2.02/bank/debit/@app/08EB3775-92FB-34E6-83F1-C98854C924AD
Content-Type: application/json; charset=utf-8

{
"state" : "open"
}

HTTPS Response

HTTP/1.1 202 Accepted
Content-Type: application/json; charset=utf-8

{
"id" : "08EB3775-92FB-34E6-83F1-C98854C924AD",
"items": [
{
"item": {
"id": "ZZZZZZZZZ",
"name": "Sample Item",
"price": 100,
"description": "This is a sample item",
"imageUrl": "http://server/images/ZZZZZZZZZ.png"
},
"quantity": 10
}
],
"comment" : "hogehoge",
"state" : "open",
"published" : "2011-03-04T13:31:18",
"updated" : "2011-03-04T13:32:00"
}

How to Add the Authorization Header

Step 1. Create the base string**​
  1. build a string for OAuth parameters:  firstly sort the following parameters alphabetically and URL encode the names and values, then join name and value with "=", finally join name/value pairs with "&" 
ParameterDescriptionValue
oauth_consumer_keyThe Consumer Key for the applicationIssued when resist the application
oauth_nonceUnique value for each requestGenerated on the game server
oauth_signature_methodHash methodOnly HMAC-SHA1 is specifiable
oauth_timestampUNIX timestampGenerated on the game server
oauth_tokenThe token code

oauth_token is obtained from the token credential.

oauth_versionOAuth versionOnly 1.0
  1. URL encode the following three parameters.
ParameterDescription
Request MethodHTTP Method to the API Server
API URLURL to the API Server (exclude query parameters)
OAuth ParametersA string Built in previous step
  1. join the encoded parameters with "&".
Step 2. Generate the oauth_signature​
  1. Build a secret by joining the Consumer Secret and  the Token Secret (obtained from the token credential) with "&".

  2. Pass the base string and secret to the HMAC-SHA1 hashing algorithm.

  3. the output of HMAC-SHA1 hashing algorithm is a binary string. Use base64 encode to produce the signature string.

A tool is provided to verify whether your signature is correct. Refer to Oauth Signature Tool.

Step 3. Build the Authorization Header​

Follow the steps to build the “Authorization” header:

  1. URL encode the parameter names and values in the table below

  2. Double quote the value, join name and value with "=", join name/value pairs with "," 

  3. Add realm parameter as an option

  4. Add "OAuth " (including the space at the end) to the beginning of the header.

ParameterValue
oauth_consumer_keyIssued when resist the application
oauth_nonceGenerated on the game server
oauth_signatureGenerated on the game server, Refer to Step 2. Generate the oauth_signature
oauth_signature_methodonly "HMAC-SHA1" is specifiable
oauth_timestampGenerated on the game server
oauth_token

oauth_token is obtained from the token credential.

oauth_versionOnly 1.0
Authorization Header Example​
OAuth realm="", oauth_consumer_key="195dcf3f2b64da74549f", oauth_nonce="abb5031d1d767d3626e4", oauth_signature="nzWySwCI9oIUU9mSTnIvrti7V7I%3D", oauth_signature_method="HMAC-SHA1", oauth_timestamp="1363057344", oauth_token="sp_client_id%3A6317c85392724d8914904f708f16d01d", oauth_version="1.0"

Appendix

These sequence diagrams display patterns for the Bank Debit APIs.